This document explains how to create virtual machine (VM) instances in bulk that
use the A2 series, which includes A2 Ultra or A2 Standard machine types. To
learn more about these accelerator-optimized machine types, see
[A2 series](https://docs.cloud.google.com/ai-hypercomputer/docs/evaluate-general-gpus.md.txt#a2).

For more information about creating VMs in bulk, see
[About bulk creation of VMs](https://docs.cloud.google.com/compute/docs/instances/multiple/about-bulk-creation.md.txt)
in the Compute Engine documentation.

To learn about other ways to create VMs or clusters, see
[Deployment options overview](https://docs.cloud.google.com/ai-hypercomputer/docs/create/create-overview.md.txt).

## Limitations

When you create A2 Ultra or A2 Standard VMs in bulk, the following limitations apply:

### A2 Ultra


- You don't receive [sustained
  use discounts](https://docs.cloud.google.com/compute/docs/sustained-use-discounts) and [flexible committed use](https://docs.cloud.google.com/compute/docs/instances/committed-use-discounts-overview.md.txt#spend_based) discounts for instances that use an A2 Ultra machine type.
- You can only use an A2 Ultra machine type in certain [regions
  and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones#view-using-table).
- The A2 Ultra machine type is only available on the [Cascade Lake platform](https://docs.cloud.google.com/compute/docs/cpu-platforms.md.txt).
- If your instance uses an A2 Ultra machine type, you can't change the machine type. If you need to use a different A2 Ultra machine type, or any other machine type, you must create a new instance.
- You can't change any other machine type to an A2 Ultra machine type. If you need a instance that uses an A2 Ultra machine type, you must create a new instance.
- You can't do a quick format of the attached Local SSDs on Windows instances that use A2 Ultra machine types. To format these Local SSDs, you must do a full format by using the [diskpart
  utility](https://docs.microsoft.com/windows-server/administration/windows-commands/diskpart) and specifying `format fs=ntfs label=tmpfs`.

<br />

### A2 Standard


- You don't receive [sustained
  use discounts](https://docs.cloud.google.com/compute/docs/sustained-use-discounts) and [flexible committed use](https://docs.cloud.google.com/compute/docs/instances/committed-use-discounts-overview.md.txt#spend_based) discounts for instances that use an A2 Standard machine type.
- You can only use an A2 Standard machine type in certain [regions
  and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones#view-using-table).
- The A2 Standard machine type is only available on the [Cascade Lake platform](https://docs.cloud.google.com/compute/docs/cpu-platforms.md.txt#intel_processors).
- If your instance uses an A2 Standard machine type, you can only switch from one A2 Standard machine type type to another A2 Standard machine type. You can't change to any other machine type. For more information, see [Modify accelerator-optimized instances](https://docs.cloud.google.com/compute/docs/gpus/add-remove-gpus.md.txt#accelerator-optimized_vms).
- You can't use the Windows operating system with the `a2-megagpu-16g` machine type. When using a Windows operating system, choose a different A2 Standard machine type.
- You can't do a quick format of the attached Local SSDs on Windows instances that use A2 Standard machine types. To format these Local SSDs, you must do a full format by using the [diskpart
  utility](https://docs.microsoft.com/windows-server/administration/windows-commands/diskpart) and specifying `format fs=ntfs label=tmpfs`.

<br />

If you want to use a compact placement policy, then review the [restrictions for placement policies](https://docs.cloud.google.com/compute/docs/instances/placement-policies-overview.md.txt#restrictions).

## Before you begin

Before creating VMs in bulk, if you haven't already done so, complete the following
steps:

1. **Choose a consumption option** : your choice of consumption option determines how you get and use GPU resources. To learn more, see [Choose a consumption option](https://docs.cloud.google.com/ai-hypercomputer/docs/consumption-models.md.txt).
2. **Obtain capacity** : the process to obtain capacity differs for each consumption option. To learn about the process to obtain capacity for your chosen consumption option, see [Capacity overview](https://docs.cloud.google.com/ai-hypercomputer/docs/obtain-capacity.md.txt).

Select the tab for how you plan to use the samples on this page:

### Console


When you use the Google Cloud console to access Google Cloud services and
APIs, you don't need to set up authentication.

### gcloud

In the Google Cloud console, activate Cloud Shell.

[Activate Cloud Shell](https://console.cloud.google.com/?cloudshell=true)


At the bottom of the Google Cloud console, a
[Cloud Shell](https://docs.cloud.google.com/shell/docs/how-cloud-shell-works.md.txt)
session starts and displays a command-line prompt. Cloud Shell is a shell environment
with the Google Cloud CLI
already installed and with values already set for
your current project. It can take a few seconds for the session to initialize.

### REST


To use the REST API samples on this page in a local development environment, you use the
credentials you provide to the gcloud CLI.

1. [Install](https://docs.cloud.google.com/sdk/docs/install) the Google Cloud CLI.
2. If you're using an external identity provider (IdP), you must first [sign in to the gcloud CLI with your federated identity](https://docs.cloud.google.com/iam/docs/workforce-log-in-gcloud.md.txt).


For more information, see
[Authenticate for using REST](https://docs.cloud.google.com/docs/authentication/rest.md.txt)
in the Google Cloud authentication documentation.

### Required roles


To get the permissions that
you need to create VMs in bulk,

ask your administrator to grant you the
[Compute Instance Admin (v1)](https://docs.cloud.google.com/iam/docs/roles-permissions/compute.md.txt#compute.instanceAdmin.v1) (`roles/compute.instanceAdmin.v1`) IAM role on the project.


For more information about granting roles, see [Manage access to projects, folders, and organizations](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access.md.txt).


This predefined role contains

the permissions required to create VMs in bulk. To see the exact permissions that are
required, expand the **Required permissions** section:


#### Required permissions

The following permissions are required to create VMs in bulk:

- `compute.instances.create` on the project
- To use a custom image to create the VM: `compute.images.useReadOnly` on the image
- To use a snapshot to create the VM: `compute.snapshots.useReadOnly` on the snapshot
- To use an instance template to create the VM: `compute.instanceTemplates.useReadOnly` on the instance template
- To specify a subnet for your VM: `compute.subnetworks.use` on the project or on the chosen subnet
- To specify a static IP address for the VM: `compute.addresses.use` on the project
- To assign an external IP address to the VM when using a VPC network: `compute.subnetworks.useExternalIp` on the project or on the chosen subnet
- To assign a [legacy network](https://docs.cloud.google.com/vpc/docs/legacy.md.txt) to the VM: `compute.networks.use` on the project
- To assign an external IP address to the VM when using a legacy network: `compute.networks.useExternalIp` on the project
- To set VM instance metadata for the VM: `compute.instances.setMetadata` on the project
- To set tags for the VM: `compute.instances.setTags` on the VM
- To set labels for the VM: `compute.instances.setLabels` on the VM
- To set a service account for the VM to use: `compute.instances.setServiceAccount` on the VM
- To create a new disk for the VM: `compute.disks.create` on the project
- To attach an existing disk in read-only or read-write mode: `compute.disks.use` on the disk
- To attach an existing disk in read-only mode: `compute.disks.useReadOnly` on the disk


You might also be able to get
these permissions
with [custom roles](https://docs.cloud.google.com/iam/docs/creating-custom-roles.md.txt) or
other [predefined roles](https://docs.cloud.google.com/iam/docs/roles-overview.md.txt#predefined).

## Overview

Creating instances in bulk with the A2 machine type includes the following steps:

1. Optional:[Create a compact placement policy](https://docs.cloud.google.com/ai-hypercomputer/docs/create/create-vms-in-bulk-a2.md.txt#create-compact-placement-policy)
2. [Create instances in bulk](https://docs.cloud.google.com/ai-hypercomputer/docs/create/create-vms-in-bulk-a2.md.txt#create-instances-in-bulk)
3. [Install GPU drivers](https://docs.cloud.google.com/ai-hypercomputer/docs/create/create-vms-in-bulk-a2.md.txt#install-drivers)
4. Optional: [Enable NVIDIA Multi-Instance GPU mode](https://docs.cloud.google.com/ai-hypercomputer/docs/create/create-vms-in-bulk-a2.md.txt#multi-instance-gpu-mode)

### Optional: Create a compact placement policy

> [!TIP]
> **Tip:** Decide whether to create a compact placement policy as follows:
>
> - If you want to place your VMs in single or adjacent blocks, then specify VM placement by creating a compact placement policy and applying it when you create VMs.

You can specify VM placement by creating a compact placement policy. When you apply a compact
placement policy to your VMs, Compute Engine makes best-effort attempts to create VMs that
are as close to each other as possible. If your application is latency-sensitive and requires
maximum compactness, then specify the `maxDistance` field
([Preview](https://cloud.google.com/products/#product-launch-stages)) when you create a
compact placement policy. A lower `maxDistance` value ensures closer VM placement, but
it also increases the chance that some VMs won't be created.
To create a compact placement policy, select one of the following options:

### gcloud

To create a compact placement policy, use the
[`gcloud compute resource-policies create group-placement` command](https://docs.cloud.google.com/sdk/gcloud/reference/compute/resource-policies/create/group-placement):

```
gcloud compute resource-policies create group-placement POLICY_NAME \
    --collocation=collocated \
    --max-distance=MAX_DISTANCE \
    --region=REGION
```

Replace the following:

- `POLICY_NAME`: the name of the compact placement policy.
- `MAX_DISTANCE`: the maximum distance configuration for your VMs, which can either be specified ([Preview](https://cloud.google.com/products/#product-launch-stages), recommended) or unspecified (remove the `--max-distance` flag). Based on what your machine type supports, you can specify one of the following values:
  - To place VMs in the same sub-block: `1`
  - To place VMs in the same block: `2`
  - To place VMs in adjacent blocks: `3`

  Ensure that the maximum distance configuration supports the machine series and number of VMs that you plan to create. For more information, see [About compact placement policies](https://docs.cloud.google.com/compute/docs/instances/placement-policies-overview.md.txt#about-compact-policies) in the Compute Engine documentation.
- `REGION`: the region where you want to create the compact placement policy. Specify the region that contains the zone where you plan to create instances, and verify that the machine type that you want to use is available in that region. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).

### REST

To create a compact placement policy, make a `POST` request to the
[`resourcePolicies.insert` method](https://docs.cloud.google.com/compute/docs/reference/rest/v1/resourcePolicies.md.txt).
In the request body, include the
`collocation` field set to `COLLOCATED`, and the `maxDistance`
field.

```
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/regions/REGION/resourcePolicies
  {
    "name": "POLICY_NAME",
    "groupPlacementPolicy": {
      "collocation": "COLLOCATED",
      "maxDistance": MAX_DISTANCE
    }
  }
```

Replace the following:

- `PROJECT_ID`: your project ID.
- `POLICY_NAME`: the name of the compact placement policy.
- `MAX_DISTANCE`: the maximum distance configuration for your VMs, which can either be specified ([Preview](https://cloud.google.com/products/#product-launch-stages), recommended) or unspecified (remove the `maxDistance` field). Based on what your machine type supports, you can specify one of the following values:
  - To place VMs in the same sub-block: `1`
  - To place VMs in the same block: `2`
  - To place VMs in adjacent blocks: `3`

  Ensure that the maximum distance configuration supports the machine series and number of VMs that you plan to create. For more information, see [About compact placement policies](https://docs.cloud.google.com/compute/docs/instances/placement-policies-overview.md.txt#about-compact-policies) in the Compute Engine documentation.
- `REGION`: the region where you want to create the compact placement policy. Specify the region that contains the zone where you plan to create instances, and verify that the machine type that you want to use is available in that region. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).

<br />

### Create A2 VMs in bulk

To create an A2 VM, use one of the following methods.
The following commands also set the access scope for your instances. To simplify permissions management, Google recommends that you set the access scope on an instance to `cloud-platform` access and then use IAM roles to define what services the instance can access. For more information, see [Scopes best practice](https://docs.cloud.google.com/compute/docs/access/service-accounts.md.txt#scopes_best_practice).

### gcloud


To create
instances in
bulk, use the [`gcloud compute instances bulk create` command](https://docs.cloud.google.com/sdk/gcloud/reference/compute/instances/bulk/create.md.txt).

The parameters that you need to specify depend on the
[consumption option](https://docs.cloud.google.com/ai-hypercomputer/docs/consumption-models.md.txt) that you are using for
this deployment. Select the tab that corresponds to your consumption option.

### Reservation

A2 instances support the following
[types of reservations](https://docs.cloud.google.com/compute/docs/instances/choose-reservation-type.md.txt):

- On-demand reservations
- Standard future reservations

To consume these types of reservations, an instance must use the
*standard provisioning model*. For example, use the following creation parameters.

Before you run the command, review all of the following steps to determine whether to include additional flags.

```
gcloud compute instances bulk create \
    --name-pattern=NAME_PATTERN \
    --count=COUNT \
     --machine-type=MACHINE_TYPE \
    --image-family=IMAGE_FAMILY \
    --image-project=IMAGE_PROJECT \
    --region=REGION \
    --boot-disk-type=DISK_TYPE \
    --boot-disk-size=DISK_SIZE \
    --scopes=cloud-platform \
    --provisioning-model=STANDARD \
    --maintenance-policy=TERMINATE \
    --reservation-affinity=RESERVATION_AFFINITY \
    --reservation=RESERVATION
```

Complete the following steps:

1. Replace the following:

   - `NAME_PATTERN`: the name pattern to use for the A2 instances. For example, using `instance-#` for the name pattern generates A2 instances with names such as `instance-1` and `instance-2`, up to the number of A2 instances specified by `--count`.
   - `COUNT`: the number of A2 instances to create.
   - `MACHINE_TYPE`: the machine type to use for the A2 instance. For more information, see [GPU machine types](https://docs.cloud.google.com/compute/docs/gpus.md.txt) in the Compute Engine documentation.
   - `IMAGE_FAMILY`: the image family of the OS image that you want to use. For a list of all supported operating systems, see [Supported operating systems](https://docs.cloud.google.com/compute/docs/images/os-details.md.txt#gpu-support).
   - `IMAGE_PROJECT`: the project ID of the OS image.
   - `REGION`: specify a region in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use the same region as the compact placement policy. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).
   - `DISK_TYPE`: the type of the boot disk. For more information about the supported disk types for your machine type, see [GPU machines in accelerator-optimized machine family](https://docs.cloud.google.com/compute/docs/accelerator-optimized-machines.md.txt) in the Compute Engine documentation.
   - `DISK_SIZE`: the size of the boot disk in GB. For more information, see either [Google Cloud Hyperdisk size limits](https://docs.cloud.google.com/compute/docs/disks/hyperdisks.md.txt#size-limits) or [Persistent Disk size limits](https://docs.cloud.google.com/compute/docs/disks/resize-persistent-disk.md.txt#size_limits) based on the type of disk.
   - `RESERVATION_AFFINITY`: which reservations the instance is allowed to
     consume, if possible. Specify one of the following:

     - **`any` (Reservation capacity is optional)** : this is the default option. The instance tries to use capacity from an
       [*automatically consumed* reservation](https://docs.cloud.google.com/compute/docs/instances/reservations-overview.md.txt#consumption-type),
       which only happens if matching reservation capacity is available. Otherwise, the instance uses
       on-demand capacity.

     > [!CAUTION]
     > **Caution:** When matching reservation capacity is unavailable, the instance uses the on-demand consumption option instead, which has different billing and capacity assurance. For more information, see [Choose a consumption option](https://docs.cloud.google.com/ai-hypercomputer/docs/consumption-models.md.txt).

     - **`specific` (Reservation capacity is required)** : Require the instance to use capacity from a
       [*specifically targeted* reservation](https://docs.cloud.google.com/compute/docs/instances/reservations-overview.md.txt#consumption-type).
       The instance isn't allowed to use on-demand capacity. If reservation capacity is unavailable, then the instance creation fails.

   - `RESERVATION`: the reservation to use. Specify one of the following based on the value you specified for `RESERVATION_AFFINITY`:

     - If you specified `any`, then replace `RESERVATION` with an empty string (`""`). Alternatively, you can remove the `--reservation` flag entirely.
     - If you specified `specific`, then replace `RESERVATION` with the following:

       ```
       projects/RESERVATION_OWNER_PROJECT_ID/reservations/RESERVATION_NAME
       ```

       Replace the following:
       - `RESERVATION_OWNER_PROJECT_ID`: the project ID of the project where the reservation was created.

       > [!TIP]
       > **Tip:** If the reservation exists in the current project, then you can omit `projects/RESERVATION_OWNER_PROJECT_ID/reservations/` from the `RESERVATION` value.

       - `RESERVATION_NAME`: the name of the reservation.
2. By default, the instance automatically restarts if it crashes or Compute Engine
   stops it for a programmed stop, such as a maintenance event. If you want to disable automatic
   restart, then add the following flag:

   ```
   --no-restart-on-failure
   ```
3. Optional: If you chose to use a compact placement policy, then
   add the following flag to the command:

   ```
   --resource-policies=POLICY_NAME
   ```

   Replace the following:
   - `POLICY_NAME`: the name of the compact placement policy.
4. Optional: If you specified an A2 Standard machine type and want to
   attach Local SSD disks, then add the following `--local-ssd` flag for *each*
   Local SSD disk.

   Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for
   details, see
   [About Local SSD disks](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#lssd_disk_options) in the
   Compute Engine documentation.

   > [!NOTE]
   > **Note:** A2 Ultra machine types automatically include Local SSD disks.

   ```
   --local-ssd interface=INTERFACE_TYPE
   ```

   Replace the following:
   - `INTERFACE_TYPE`: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has [optimized NVMe drivers](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#choose_an_interface), then specify `NVME`. Specify `SCSI` for other images.

   After creating a VM with Local SSD disks, you must
   [format and mount each device](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#formatandmount) before you
   can use it.
5. Run the command.

### On-demand

Before you run the command, review all of the following steps to determine whether to include additional flags.

```
gcloud compute instances bulk create \
    --name-pattern=NAME_PATTERN \
    --count=COUNT \
     --machine-type=MACHINE_TYPE \
    --image-family=IMAGE_FAMILY \
    --image-project=IMAGE_PROJECT \
    --region=REGION \
    --boot-disk-type=DISK_TYPE \
    --boot-disk-size=DISK_SIZE \
    --scopes=cloud-platform \
    --provisioning-model=STANDARD \
    --maintenance-policy=TERMINATE \
    --reservation-affinity=RESERVATION_AFFINITY
```

Complete the following steps:

1. Replace the following:

   - `NAME_PATTERN`: the name pattern to use for the A2 instances. For example, using `instance-#` for the name pattern generates A2 instances with names such as `instance-1` and `instance-2`, up to the number of A2 instances specified by `--count`.
   - `COUNT`: the number of A2 instances to create.
   - `MACHINE_TYPE`: the machine type to use for the A2 instance. For more information, see [GPU machine types](https://docs.cloud.google.com/compute/docs/gpus.md.txt) in the Compute Engine documentation.
   - `IMAGE_FAMILY`: the image family of the OS image that you want to use. For a list of all supported operating systems, see [Supported operating systems](https://docs.cloud.google.com/compute/docs/images/os-details.md.txt#gpu-support).
   - `IMAGE_PROJECT`: the project ID of the OS image.
   - `REGION`: specify a region in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use the same region as the compact placement policy. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).
   - `DISK_TYPE`: the type of the boot disk. For more information about the supported disk types for your machine type, see [GPU machines in accelerator-optimized machine family](https://docs.cloud.google.com/compute/docs/accelerator-optimized-machines.md.txt) in the Compute Engine documentation.
   - `DISK_SIZE`: the size of the boot disk in GB. For more information, see either [Google Cloud Hyperdisk size limits](https://docs.cloud.google.com/compute/docs/disks/hyperdisks.md.txt#size-limits) or [Persistent Disk size limits](https://docs.cloud.google.com/compute/docs/disks/resize-persistent-disk.md.txt#size_limits) based on the type of disk.
   - `RESERVATION_AFFINITY`: which reservations the instance is allowed to
     consume, if possible. Specify one of the following:

     - **`any` (Reservation capacity is optional)** : this is the default option. The instance tries to use capacity from an
       [*automatically consumed* reservation](https://docs.cloud.google.com/compute/docs/instances/reservations-overview.md.txt#consumption-type),
       which only happens if matching reservation capacity is available. Otherwise, the instance uses
       on-demand capacity.

     > [!NOTE]
     > **Note:** If you want using reservation capacity to be *required*, then follow the *Reservation* steps instead.

     - **`none` (On-demand capacity is required)**: Block the instance from using any reservation
       capacity.

2. By default, the instance automatically restarts if it crashes or Compute Engine
   stops it for a programmed stop, such as a maintenance event. If you want to disable automatic
   restart, then add the following flag:

   ```
   --no-restart-on-failure
   ```
3. Optional: If you chose to use a compact placement policy, then
   add the following flag to the command:

   ```
   --resource-policies=POLICY_NAME
   ```

   Replace the following:
   - `POLICY_NAME`: the name of the compact placement policy.
4. Optional: If you specified an A2 Standard machine type and want to
   attach Local SSD disks, then add the following `--local-ssd` flag for *each*
   Local SSD disk.

   Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for
   details, see
   [About Local SSD disks](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#lssd_disk_options) in the
   Compute Engine documentation.

   > [!NOTE]
   > **Note:** A2 Ultra machine types automatically include Local SSD disks.

   ```
   --local-ssd interface=INTERFACE_TYPE
   ```

   Replace the following:
   - `INTERFACE_TYPE`: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has [optimized NVMe drivers](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#choose_an_interface), then specify `NVME`. Specify `SCSI` for other images.

   After creating a VM with Local SSD disks, you must
   [format and mount each device](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#formatandmount) before you
   can use it.
5. Run the command.

### Spot

Before you run the command, review all of the following steps to determine whether to include additional flags.

```
gcloud compute instances bulk create \
    --name-pattern=NAME_PATTERN \
    --count=COUNT \
     --machine-type=MACHINE_TYPE \
    --image-family=IMAGE_FAMILY \
    --image-project=IMAGE_PROJECT \
    --region=REGION \
    --boot-disk-type=DISK_TYPE \
    --boot-disk-size=DISK_SIZE \
    --scopes=cloud-platform \
    --provisioning-model=SPOT \
    --instance-termination-action=TERMINATION_ACTION \
    --maintenance-policy=TERMINATE \
    --no-restart-on-failure
```

Complete the following steps:

1. Replace the following:

   - `NAME_PATTERN`: the name pattern to use for the A2 instances. For example, using `instance-#` for the name pattern generates A2 instances with names such as `instance-1` and `instance-2`, up to the number of A2 instances specified by `--count`.
   - `COUNT`: the number of A2 instances to create.
   - `MACHINE_TYPE`: the machine type to use for the A2 instance. For more information, see [GPU machine types](https://docs.cloud.google.com/compute/docs/gpus.md.txt) in the Compute Engine documentation.
   - `IMAGE_FAMILY`: the image family of the OS image that you want to use. For a list of all supported operating systems, see [Supported operating systems](https://docs.cloud.google.com/compute/docs/images/os-details.md.txt#gpu-support).
   - `IMAGE_PROJECT`: the project ID of the OS image.
   - `REGION`: specify a region in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use the same region as the compact placement policy. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).
   - `DISK_TYPE`: the type of the boot disk. For more information about the supported disk types for your machine type, see [GPU machines in accelerator-optimized machine family](https://docs.cloud.google.com/compute/docs/accelerator-optimized-machines.md.txt) in the Compute Engine documentation.
   - `DISK_SIZE`: the size of the boot disk in GB. For more information, see either [Google Cloud Hyperdisk size limits](https://docs.cloud.google.com/compute/docs/disks/hyperdisks.md.txt#size-limits) or [Persistent Disk size limits](https://docs.cloud.google.com/compute/docs/disks/resize-persistent-disk.md.txt#size_limits) based on the type of disk.
   - `TERMINATION_ACTION`: the action to take when Compute Engine
     preempts the instance, either `STOP` (default) or `DELETE`.

     **Important:** Make sure your application can handle preemption. For example, handle preemption by specifying a shutdown script during instance creation. Learn how to [handle
     preemption with a shutdown script](https://docs.cloud.google.com/compute/docs/instances/create-use-spot#handle-preemption).
2. Optional: If you chose to use a compact placement policy, then
   add the following flag to the command:

   ```
   --resource-policies=POLICY_NAME
   ```

   Replace the following:
   - `POLICY_NAME`: the name of the compact placement policy.
3. Optional: If you specified an A2 Standard machine type and want to
   attach Local SSD disks, then add the following `--local-ssd` flag for *each*
   Local SSD disk.

   Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for
   details, see
   [About Local SSD disks](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#lssd_disk_options) in the
   Compute Engine documentation.

   > [!NOTE]
   > **Note:** A2 Ultra machine types automatically include Local SSD disks.

   ```
   --local-ssd interface=INTERFACE_TYPE
   ```

   Replace the following:
   - `INTERFACE_TYPE`: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has [optimized NVMe drivers](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#choose_an_interface), then specify `NVME`. Specify `SCSI` for other images.

   After creating a VM with Local SSD disks, you must
   [format and mount each device](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#formatandmount) before you
   can use it.
4. Run the command.

<br />

### REST


To create
instances in
bulk, make a `POST` request to the
[`instances.bulkInsert` method](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/bulkInsert.md.txt).

The parameters that you need to specify depend on the
[consumption option](https://docs.cloud.google.com/ai-hypercomputer/docs/consumption-models.md.txt) that you are using for
this deployment. Select the tab that corresponds to your consumption option.

### Reservation

A2 instances support the following
[types of reservations](https://docs.cloud.google.com/compute/docs/instances/choose-reservation-type.md.txt):

- On-demand reservations
- Standard future reservations

To consume these types of reservations, an instance must use the
*standard provisioning model*. For example, use the following creation parameters.

Before you submit the request, review all of the following steps to determine whether to include additional fields.

```
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/bulkInsert
{
  "namePattern": "NAME_PATTERN",
  "count": "COUNT",
  "instanceProperties": {
    "machineType": "MACHINE_TYPE",
    "disks": [
      {
        "boot": true,
        "initializeParams": {
          "diskSizeGb": "DISK_SIZE",
          "diskType": "DISK_TYPE",
          "sourceImage": "projects/IMAGE_PROJECT/global/images/family/IMAGE_FAMILY"
        },
        "mode": "READ_WRITE",
        "type": "PERSISTENT"
      }
    ],
    "serviceAccounts": [
      {
        "email": "default",
        "scopes": [
          "https://www.googleapis.com/auth/cloud-platform"
        ]
      }
    ],
    "scheduling": {
    "provisioningModel": "STANDARD",
    "onHostMaintenance": "TERMINATE",
    "automaticRestart": AUTOMATIC_RESTART
  },
  "reservationAffinity": {
    "consumeReservationType": "RESERVATION_AFFINITY",
    "key": "compute.googleapis.com/reservation-name",
    "values": [
      "RESERVATION"
    ]
  }
  }
}
```

Complete the following steps:

1. Replace the following:

   - `PROJECT_ID`: the project ID of the project where you want to create the A2 instance.
   - `ZONE`: specify a zone in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use a zone in the same region as the compact placement policy. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).
   - `NAME_PATTERN`: the name pattern to use for the A2 instances. For example, using `instance-#` for the name pattern generates A2 instances with names such as `instance-1` and `instance-2`, up to the number of A2 instances specified by `--count`.
   - `COUNT`: the number of A2 instances to create.
   - `MACHINE_TYPE`: the machine type to use for the A2 instance. For more information, see [GPU machine types](https://docs.cloud.google.com/compute/docs/gpus.md.txt) in the Compute Engine documentation.
   - `DISK_SIZE`: the size of the boot disk in GB. For more information, see either [Google Cloud Hyperdisk size limits](https://docs.cloud.google.com/compute/docs/disks/hyperdisks.md.txt#size-limits) or [Persistent Disk size limits](https://docs.cloud.google.com/compute/docs/disks/resize-persistent-disk.md.txt#size_limits) based on the type of disk.
   - `DISK_TYPE`: the type of the boot disk. For more information about the supported disk types for your machine type, see [GPU machines in accelerator-optimized machine family](https://docs.cloud.google.com/compute/docs/accelerator-optimized-machines.md.txt) in the Compute Engine documentation.
   - `IMAGE_PROJECT`: the project ID of the OS image.
   - `IMAGE_FAMILY`: the image family of the OS image that you want to use. For a list of all supported operating systems, see [Supported operating systems](https://docs.cloud.google.com/compute/docs/images/os-details.md.txt#gpu-support).
   - `AUTOMATIC_RESTART`: if your instance automatically
     restarts if it crashes or Compute Engine stops it for a programmed stop, such as a
     maintenance event. Specify either `true` to enable automatic restart (default) or
     `false` to disable automatic restart.

   - `RESERVATION_AFFINITY`: which reservations the instance is allowed to
     consume, if possible. Specify one of the following:

     - **`ANY_RESERVATION` (Reservation capacity is optional)** : this is the default option. The instance tries to use capacity from an
       [*automatically consumed* reservation](https://docs.cloud.google.com/compute/docs/instances/reservations-overview.md.txt#consumption-type),
       which only happens if matching reservation capacity is available. Otherwise, the instance uses
       on-demand capacity.

     > [!CAUTION]
     > **Caution:** When matching reservation capacity is unavailable, the instance uses the on-demand consumption option instead, which has different billing and capacity assurance. For more information, see [Choose a consumption option](https://docs.cloud.google.com/ai-hypercomputer/docs/consumption-models.md.txt).

     - **`SPECIFIC_RESERVATION` (Reservation capacity is required)** : Require the instance to use capacity from a
       [*specifically targeted* reservation](https://docs.cloud.google.com/compute/docs/instances/reservations-overview.md.txt#consumption-type).
       The instance isn't allowed to use on-demand capacity. If reservation capacity is unavailable, then the instance creation fails.

   - `RESERVATION`: the reservation to use. Specify one of the following based on the value you specified for `RESERVATION_AFFINITY`:

     - If you specified `ANY_RESERVATION`, then delete `RESERVATION` so that the value is an empty string (`""`). Alternatively, you can remove the `key` and `values` fields entirely.
     - If you specified `SPECIFIC_RESERVATION`, then replace `RESERVATION` with the following:

       ```
       projects/RESERVATION_OWNER_PROJECT_ID/reservations/RESERVATION_NAME
       ```

       Replace the following:
       - `RESERVATION_OWNER_PROJECT_ID`: the project ID of the project where the reservation was created.

       > [!TIP]
       > **Tip:** If the reservation exists in the current project, then you can omit `projects/RESERVATION_OWNER_PROJECT_ID/reservations/` from the `RESERVATION` value.

       - `RESERVATION_NAME`: the name of the reservation.
2. Optional: If you chose to use a compact placement policy, then
   add the following `instanceProperties` subfield to the request body:

   ```
       "resourcePolicies": [
         "projects/PROJECT_ID/regions/REGION/resourcePolicies/POLICY_NAME"
       ]
   ```

   Replace the following:
   - `PROJECT_ID`: the project ID of the compact placement policy.
   - `REGION`: the region of the compact placement policy.
   - `POLICY_NAME`: the name of the compact placement policy.
3. Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then
   add the following field to the `disks[]` field for *each* Local SSD disk. Separate
   each `disks[]` subfield (including the boot disk) with a comma.

   Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for
   details, see
   [About Local SSD disks](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#lssd_disk_options) in the
   Compute Engine documentation.

   > [!NOTE]
   > **Note:** A2 Ultra machine types automatically include Local SSD disks.

   ```
       {
          "type": "SCRATCH",
          "initializeParams": {
             "diskType": "zones/ZONE/diskTypes/local-ssd"
          },
          "autoDelete": true,
          "interface": "INTERFACE_TYPE"
       }
   ```

   Replace the following:
   - `ZONE`: your specified zone.
   - `INTERFACE_TYPE`: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has [optimized NVMe drivers](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#choose_an_interface), then specify `NVME`. Specify `SCSI` for other images.

   After creating a VM with Local SSD disks, you must
   [format and mount each device](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#formatandmount) before you
   can use it.
4. Submit the request.

### On-demand

Before you submit the request, review all of the following steps to determine whether to include additional fields.

```
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/bulkInsert
{
  "namePattern": "NAME_PATTERN",
  "count": "COUNT",
  "instanceProperties": {
    "machineType": "MACHINE_TYPE",
    "disks": [
      {
        "boot": true,
        "initializeParams": {
          "diskSizeGb": "DISK_SIZE",
          "diskType": "DISK_TYPE",
          "sourceImage": "projects/IMAGE_PROJECT/global/images/family/IMAGE_FAMILY"
        },
        "mode": "READ_WRITE",
        "type": "PERSISTENT"
      }
    ],
    "serviceAccounts": [
      {
        "email": "default",
        "scopes": [
          "https://www.googleapis.com/auth/cloud-platform"
        ]
      }
    ],
    "scheduling": {
    "provisioningModel": "STANDARD",
    "onHostMaintenance": "TERMINATE",
    "automaticRestart": AUTOMATIC_RESTART
  },
  "reservationAffinity": {
    "consumeReservationType": "RESERVATION_AFFINITY"
  }
  }
}
```

Complete the following steps:

1. Replace the following:

   - `PROJECT_ID`: the project ID of the project where you want to create the A2 instance.
   - `ZONE`: specify a zone in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use a zone in the same region as the compact placement policy. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).
   - `NAME_PATTERN`: the name pattern to use for the A2 instances. For example, using `instance-#` for the name pattern generates A2 instances with names such as `instance-1` and `instance-2`, up to the number of A2 instances specified by `--count`.
   - `COUNT`: the number of A2 instances to create.
   - `MACHINE_TYPE`: the machine type to use for the A2 instance. For more information, see [GPU machine types](https://docs.cloud.google.com/compute/docs/gpus.md.txt) in the Compute Engine documentation.
   - `DISK_SIZE`: the size of the boot disk in GB. For more information, see either [Google Cloud Hyperdisk size limits](https://docs.cloud.google.com/compute/docs/disks/hyperdisks.md.txt#size-limits) or [Persistent Disk size limits](https://docs.cloud.google.com/compute/docs/disks/resize-persistent-disk.md.txt#size_limits) based on the type of disk.
   - `DISK_TYPE`: the type of the boot disk. For more information about the supported disk types for your machine type, see [GPU machines in accelerator-optimized machine family](https://docs.cloud.google.com/compute/docs/accelerator-optimized-machines.md.txt) in the Compute Engine documentation.
   - `IMAGE_PROJECT`: the project ID of the OS image.
   - `IMAGE_FAMILY`: the image family of the OS image that you want to use. For a list of all supported operating systems, see [Supported operating systems](https://docs.cloud.google.com/compute/docs/images/os-details.md.txt#gpu-support).
   - `AUTOMATIC_RESTART`: if your instance automatically
     restarts if it crashes or Compute Engine stops it for a programmed stop, such as a
     maintenance event. Specify either `true` to enable automatic restart (default) or
     `false` to disable automatic restart.

   - `RESERVATION_AFFINITY`: which reservations the instance is allowed to
     consume, if possible. Specify one of the following:

     - **`ANY_RESERVATION` (Reservation capacity is optional)** : this is the default option. The instance tries to use capacity from an
       [*automatically consumed* reservation](https://docs.cloud.google.com/compute/docs/instances/reservations-overview.md.txt#consumption-type),
       which only happens if matching reservation capacity is available. Otherwise, the instance uses
       on-demand capacity.

     > [!NOTE]
     > **Note:** If you want using reservation capacity to be *required*, then follow the *Reservation* steps instead.

     - **`NO_RESERVATION` (On-demand capacity is required)**: Block the instance from using any reservation
       capacity.

2. Optional: If you chose to use a compact placement policy, then
   add the following `instanceProperties` subfield to the request body:

   ```
       "resourcePolicies": [
         "projects/PROJECT_ID/regions/REGION/resourcePolicies/POLICY_NAME"
       ]
   ```

   Replace the following:
   - `PROJECT_ID`: the project ID of the compact placement policy.
   - `REGION`: the region of the compact placement policy.
   - `POLICY_NAME`: the name of the compact placement policy.
3. Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then
   add the following field to the `disks[]` field for *each* Local SSD disk. Separate
   each `disks[]` subfield (including the boot disk) with a comma.

   Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for
   details, see
   [About Local SSD disks](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#lssd_disk_options) in the
   Compute Engine documentation.

   > [!NOTE]
   > **Note:** A2 Ultra machine types automatically include Local SSD disks.

   ```
       {
          "type": "SCRATCH",
          "initializeParams": {
             "diskType": "zones/ZONE/diskTypes/local-ssd"
          },
          "autoDelete": true,
          "interface": "INTERFACE_TYPE"
       }
   ```

   Replace the following:
   - `ZONE`: your specified zone.
   - `INTERFACE_TYPE`: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has [optimized NVMe drivers](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#choose_an_interface), then specify `NVME`. Specify `SCSI` for other images.

   After creating a VM with Local SSD disks, you must
   [format and mount each device](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#formatandmount) before you
   can use it.
4. Submit the request.

### Spot

Before you submit the request, review all of the following steps to determine whether to include additional fields.

```
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/bulkInsert
{
  "namePattern": "NAME_PATTERN",
  "count": "COUNT",
  "instanceProperties": {
    "machineType": "MACHINE_TYPE",
    "disks": [
      {
        "boot": true,
        "initializeParams": {
          "diskSizeGb": "DISK_SIZE",
          "diskType": "DISK_TYPE",
          "sourceImage": "projects/IMAGE_PROJECT/global/images/family/IMAGE_FAMILY"
        },
        "mode": "READ_WRITE",
        "type": "PERSISTENT"
      }
    ],
    "serviceAccounts": [
      {
        "email": "default",
        "scopes": [
          "https://www.googleapis.com/auth/cloud-platform"
        ]
      }
    ],
    "scheduling":
    {
      "provisioningModel": "SPOT",
      "instanceTerminationAction": "TERMINATION_ACTION",
      "onHostMaintenance": "TERMINATE",
      "automaticRestart": false
    }
  }
}
```

Complete the following steps:

1. Replace the following:

   - `PROJECT_ID`: the project ID of the project where you want to create the A2 instance.
   - `ZONE`: specify a zone in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use a zone in the same region as the compact placement policy. For information about regions, see [GPU availability by regions and zones](https://docs.cloud.google.com/compute/docs/regions-zones/gpu-regions-zones.md.txt#view-using-table).
   - `NAME_PATTERN`: the name pattern to use for the A2 instances. For example, using `instance-#` for the name pattern generates A2 instances with names such as `instance-1` and `instance-2`, up to the number of A2 instances specified by `--count`.
   - `COUNT`: the number of A2 instances to create.
   - `MACHINE_TYPE`: the machine type to use for the A2 instance. For more information, see [GPU machine types](https://docs.cloud.google.com/compute/docs/gpus.md.txt) in the Compute Engine documentation.
   - `DISK_SIZE`: the size of the boot disk in GB. For more information, see either [Google Cloud Hyperdisk size limits](https://docs.cloud.google.com/compute/docs/disks/hyperdisks.md.txt#size-limits) or [Persistent Disk size limits](https://docs.cloud.google.com/compute/docs/disks/resize-persistent-disk.md.txt#size_limits) based on the type of disk.
   - `DISK_TYPE`: the type of the boot disk. For more information about the supported disk types for your machine type, see [GPU machines in accelerator-optimized machine family](https://docs.cloud.google.com/compute/docs/accelerator-optimized-machines.md.txt) in the Compute Engine documentation.
   - `IMAGE_PROJECT`: the project ID of the OS image.
   - `IMAGE_FAMILY`: the image family of the OS image that you want to use. For a list of all supported operating systems, see [Supported operating systems](https://docs.cloud.google.com/compute/docs/images/os-details.md.txt#gpu-support).
   - `TERMINATION_ACTION`: the action to take when Compute Engine
     preempts the instance, either `STOP` (default) or `DELETE`.

     **Important:** Make sure your application can handle preemption. For example, handle preemption by specifying a shutdown script during instance creation. Learn how to [handle
     preemption with a shutdown script](https://docs.cloud.google.com/compute/docs/instances/create-use-spot#handle-preemption).
2. Optional: If you chose to use a compact placement policy, then
   add the following `instanceProperties` subfield to the request body:

   ```
       "resourcePolicies": [
         "projects/PROJECT_ID/regions/REGION/resourcePolicies/POLICY_NAME"
       ]
   ```

   Replace the following:
   - `PROJECT_ID`: the project ID of the compact placement policy.
   - `REGION`: the region of the compact placement policy.
   - `POLICY_NAME`: the name of the compact placement policy.
3. Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then
   add the following field to the `disks[]` field for *each* Local SSD disk. Separate
   each `disks[]` subfield (including the boot disk) with a comma.

   Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for
   details, see
   [About Local SSD disks](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#lssd_disk_options) in the
   Compute Engine documentation.

   > [!NOTE]
   > **Note:** A2 Ultra machine types automatically include Local SSD disks.

   ```
       {
          "type": "SCRATCH",
          "initializeParams": {
             "diskType": "zones/ZONE/diskTypes/local-ssd"
          },
          "autoDelete": true,
          "interface": "INTERFACE_TYPE"
       }
   ```

   Replace the following:
   - `ZONE`: your specified zone.
   - `INTERFACE_TYPE`: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has [optimized NVMe drivers](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#choose_an_interface), then specify `NVME`. Specify `SCSI` for other images.

   After creating a VM with Local SSD disks, you must
   [format and mount each device](https://docs.cloud.google.com/compute/docs/disks/local-ssd.md.txt#formatandmount) before you
   can use it.
4. Submit the request.

<br />

For more information about the configuration options when creating VMs in bulk,
see [Create VMs in bulk](https://docs.cloud.google.com/compute/docs/instances/multiple/create-in-bulk.md.txt) in the
Compute Engine documentation.

### Install GPU drivers

After you create an instance, the instance can't use its GPUs unless the correct GPU drivers are
already installed.


If you didn't specify an [OS image that includes GPU drivers](https://docs.cloud.google.com/ai-hypercomputer/docs/images.md.txt#accelerator-os-images), then see
[Install GPU drivers](https://docs.cloud.google.com/compute/docs/gpus/install-drivers-gpu.md.txt) in the
Compute Engine documentation.

### Optional: Enable NVIDIA Multi-Instance GPU mode

Multi-Instance GPU (MIG) mode is a feature that you can enable for a [supported NVIDIA GPU](https://docs.nvidia.com/datacenter/tesla/mig-user-guide/latest/supported-gpus.html). After you create an instance, you can enable MIG mode on a single GPU that is attached to your machine. With MIG mode enabled, the single GPU is partitioned into as many as seven independent GPU instances. Each instance runs simultaneously, each with its own memory, cache, and streaming multiprocessors. You can then run different workloads on these GPU instances in parallel. For more information about using MIG mode, see the [Multi-Instance GPU (MIG) User Guide](https://docs.nvidia.com/datacenter/tesla/mig-user-guide/index.html#getting-started-with-mig) in the NVIDIA documentation.

## What's next

- [View the details of a VM](https://docs.cloud.google.com/compute/docs/instances/view-vm-details.md.txt)
- [Get a list of VMs](https://docs.cloud.google.com/compute/docs/instances/get-list.md.txt)
- [Verify reservation consumption](https://docs.cloud.google.com/compute/docs/instances/reservations-consume.md.txt#verify-consumption)
- [Troubleshoot reservation consumption](https://docs.cloud.google.com/compute/docs/troubleshooting/troubleshooting-reservation-consumption.md.txt)